"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.traverse = traverse;
exports.filter = filter;
exports.which = which;

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _wrapAsyncGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapAsyncGenerator"));

var _awaitAsyncGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/awaitAsyncGenerator"));

var _asyncIterator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncIterator"));

var _asyncGeneratorDelegate2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncGeneratorDelegate"));

var _fsExtra = require("fs-extra");

var _path2 = require("path");

var _child_process = require("child_process");

var _windows = require("./windows");

/**
 * Traverse File-system
 *
 * @param {string} path - Root path to traverse
 */
function traverse(_x) {
  return _traverse.apply(this, arguments);
}
/**
 * Iterator filter
 *
 * @param {Iterable}         iterator
 * @param {?(RegExp|string)} pattern          String pattern to match
 * @param {number}           [count=Infinity] Result count
 */


function _traverse() {
  _traverse = (0, _wrapAsyncGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(path) {
    var _iteratorNormalCompletion5, _didIteratorError5, _iteratorError5, _iterator5, _step5, disk, _iteratorNormalCompletion6, _didIteratorError6, _iteratorError6, _iterator6, _step6, name;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(path === '/' && process.platform === 'win32')) {
              _context.next = 27;
              break;
            }

            _iteratorNormalCompletion5 = true;
            _didIteratorError5 = false;
            _iteratorError5 = undefined;
            _context.prev = 4;
            _iterator5 = (0, _windows.getPartition)()[Symbol.iterator]();

          case 6:
            if (_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done) {
              _context.next = 12;
              break;
            }

            disk = _step5.value;
            return _context.delegateYield((0, _asyncGeneratorDelegate2.default)((0, _asyncIterator2.default)(traverse(disk)), _awaitAsyncGenerator2.default), "t0", 9);

          case 9:
            _iteratorNormalCompletion5 = true;
            _context.next = 6;
            break;

          case 12:
            _context.next = 18;
            break;

          case 14:
            _context.prev = 14;
            _context.t1 = _context["catch"](4);
            _didIteratorError5 = true;
            _iteratorError5 = _context.t1;

          case 18:
            _context.prev = 18;
            _context.prev = 19;

            if (!_iteratorNormalCompletion5 && _iterator5.return != null) {
              _iterator5.return();
            }

          case 21:
            _context.prev = 21;

            if (!_didIteratorError5) {
              _context.next = 24;
              break;
            }

            throw _iteratorError5;

          case 24:
            return _context.finish(21);

          case 25:
            return _context.finish(18);

          case 26:
            return _context.abrupt("return");

          case 27:
            _iteratorNormalCompletion6 = true;
            _didIteratorError6 = false;
            _iteratorError6 = undefined;
            _context.prev = 30;
            _context.next = 33;
            return (0, _awaitAsyncGenerator2.default)((0, _fsExtra.readdir)(path));

          case 33:
            _context.t2 = Symbol.iterator;
            _iterator6 = _context.sent[_context.t2]();

          case 35:
            if (_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done) {
              _context.next = 57;
              break;
            }

            name = _step6.value;
            name = (0, _path2.join)(path, name);
            _context.next = 40;
            return name;

          case 40:
            _context.prev = 40;
            _context.next = 43;
            return (0, _awaitAsyncGenerator2.default)((0, _fsExtra.stat)(name));

          case 43:
            if (!_context.sent.isDirectory()) {
              _context.next = 45;
              break;
            }

            return _context.delegateYield((0, _asyncGeneratorDelegate2.default)((0, _asyncIterator2.default)(traverse(name)), _awaitAsyncGenerator2.default), "t3", 45);

          case 45:
            _context.next = 54;
            break;

          case 47:
            _context.prev = 47;
            _context.t4 = _context["catch"](40);
            _context.t5 = _context.t4.code;
            _context.next = _context.t5 === 'ENOENT' ? 52 : _context.t5 === 'EPERM' ? 52 : _context.t5 === 'EBUSY' ? 52 : _context.t5 === 'ELOOP' ? 52 : _context.t5 === 'UNKNOWN' ? 52 : 53;
            break;

          case 52:
            return _context.abrupt("continue", 54);

          case 53:
            throw _context.t4;

          case 54:
            _iteratorNormalCompletion6 = true;
            _context.next = 35;
            break;

          case 57:
            _context.next = 63;
            break;

          case 59:
            _context.prev = 59;
            _context.t6 = _context["catch"](30);
            _didIteratorError6 = true;
            _iteratorError6 = _context.t6;

          case 63:
            _context.prev = 63;
            _context.prev = 64;

            if (!_iteratorNormalCompletion6 && _iterator6.return != null) {
              _iterator6.return();
            }

          case 66:
            _context.prev = 66;

            if (!_didIteratorError6) {
              _context.next = 69;
              break;
            }

            throw _iteratorError6;

          case 69:
            return _context.finish(66);

          case 70:
            return _context.finish(63);

          case 71:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[4, 14, 18, 26], [19,, 21, 25], [30, 59, 63, 71], [40, 47], [64,, 66, 70]]);
  }));
  return _traverse.apply(this, arguments);
}

function filter(_x2, _x3, _x4) {
  return _filter.apply(this, arguments);
}

function _filter() {
  _filter = (0, _wrapAsyncGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(iterator, pattern, count) {
    var index, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _value, item;

    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            index = 0;
            count = ~~count || Infinity;
            if (pattern && !(pattern instanceof RegExp)) pattern = RegExp(pattern + '', 'i');
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _context2.prev = 5;
            _iterator = (0, _asyncIterator2.default)(iterator);

          case 7:
            _context2.next = 9;
            return (0, _awaitAsyncGenerator2.default)(_iterator.next());

          case 9:
            _step = _context2.sent;
            _iteratorNormalCompletion = _step.done;
            _context2.next = 13;
            return (0, _awaitAsyncGenerator2.default)(_step.value);

          case 13:
            _value = _context2.sent;

            if (_iteratorNormalCompletion) {
              _context2.next = 26;
              break;
            }

            item = _value;

            if (!(!pattern || pattern.test(item))) {
              _context2.next = 23;
              break;
            }

            if (!(index++ < count)) {
              _context2.next = 22;
              break;
            }

            _context2.next = 20;
            return item;

          case 20:
            _context2.next = 23;
            break;

          case 22:
            return _context2.abrupt("break", 26);

          case 23:
            _iteratorNormalCompletion = true;
            _context2.next = 7;
            break;

          case 26:
            _context2.next = 32;
            break;

          case 28:
            _context2.prev = 28;
            _context2.t0 = _context2["catch"](5);
            _didIteratorError = true;
            _iteratorError = _context2.t0;

          case 32:
            _context2.prev = 32;
            _context2.prev = 33;

            if (!(!_iteratorNormalCompletion && _iterator.return != null)) {
              _context2.next = 37;
              break;
            }

            _context2.next = 37;
            return (0, _awaitAsyncGenerator2.default)(_iterator.return());

          case 37:
            _context2.prev = 37;

            if (!_didIteratorError) {
              _context2.next = 40;
              break;
            }

            throw _iteratorError;

          case 40:
            return _context2.finish(37);

          case 41:
            return _context2.finish(32);

          case 42:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this, [[5, 28, 32, 42], [33,, 37, 41]]);
  }));
  return _filter.apply(this, arguments);
}

function Shell_which(name) {
  try {
    return ((0, _child_process.execSync)("which ".concat(name)) + '').trim();
  } catch (error) {
    if (!('' + error.stdout + error.stderr).trim()) return '';
  }
}

var MacAppPath = ['/Applications', "".concat(process.env.HOME, "/Applications")].filter(_fsExtra.existsSync);
/**
 * @param {string} name - Name (without extension name) of a executable file
 *
 * @return {string} First matched path of a command
 */

function which(_x5) {
  return _which.apply(this, arguments);
}

function _which() {
  _which = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(name) {
    var _iteratorNormalCompletion7, _didIteratorError7, _iteratorError7, _iterator7, _step7, root, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, _value2, file, path, _iteratorNormalCompletion8, _didIteratorError8, _iteratorError8, _iterator8, _step8, _root, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, _value3, _file, _path, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, _value4, _file2;

    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.t0 = process.platform;
            _context3.next = _context3.t0 === 'win32' ? 3 : _context3.t0 === 'darwin' ? 61 : 122;
            break;

          case 3:
            _iteratorNormalCompletion7 = true;
            _didIteratorError7 = false;
            _iteratorError7 = undefined;
            _context3.prev = 6;
            _iterator7 = (0, _windows.getAppFolder)()[Symbol.iterator]();

          case 8:
            if (_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done) {
              _context3.next = 46;
              break;
            }

            root = _step7.value;
            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _context3.prev = 12;
            _iterator2 = (0, _asyncIterator2.default)(filter(traverse(root), "\\\\".concat(name, "\\.exe$"), 1));

          case 14:
            _context3.next = 16;
            return _iterator2.next();

          case 16:
            _step2 = _context3.sent;
            _iteratorNormalCompletion2 = _step2.done;
            _context3.next = 20;
            return _step2.value;

          case 20:
            _value2 = _context3.sent;

            if (_iteratorNormalCompletion2) {
              _context3.next = 27;
              break;
            }

            file = _value2;
            return _context3.abrupt("return", file);

          case 24:
            _iteratorNormalCompletion2 = true;
            _context3.next = 14;
            break;

          case 27:
            _context3.next = 33;
            break;

          case 29:
            _context3.prev = 29;
            _context3.t1 = _context3["catch"](12);
            _didIteratorError2 = true;
            _iteratorError2 = _context3.t1;

          case 33:
            _context3.prev = 33;
            _context3.prev = 34;

            if (!(!_iteratorNormalCompletion2 && _iterator2.return != null)) {
              _context3.next = 38;
              break;
            }

            _context3.next = 38;
            return _iterator2.return();

          case 38:
            _context3.prev = 38;

            if (!_didIteratorError2) {
              _context3.next = 41;
              break;
            }

            throw _iteratorError2;

          case 41:
            return _context3.finish(38);

          case 42:
            return _context3.finish(33);

          case 43:
            _iteratorNormalCompletion7 = true;
            _context3.next = 8;
            break;

          case 46:
            _context3.next = 52;
            break;

          case 48:
            _context3.prev = 48;
            _context3.t2 = _context3["catch"](6);
            _didIteratorError7 = true;
            _iteratorError7 = _context3.t2;

          case 52:
            _context3.prev = 52;
            _context3.prev = 53;

            if (!_iteratorNormalCompletion7 && _iterator7.return != null) {
              _iterator7.return();
            }

          case 55:
            _context3.prev = 55;

            if (!_didIteratorError7) {
              _context3.next = 58;
              break;
            }

            throw _iteratorError7;

          case 58:
            return _context3.finish(55);

          case 59:
            return _context3.finish(52);

          case 60:
            return _context3.abrupt("break", 158);

          case 61:
            path = Shell_which(name);

            if (!path) {
              _context3.next = 64;
              break;
            }

            return _context3.abrupt("return", path);

          case 64:
            _iteratorNormalCompletion8 = true;
            _didIteratorError8 = false;
            _iteratorError8 = undefined;
            _context3.prev = 67;
            _iterator8 = MacAppPath[Symbol.iterator]();

          case 69:
            if (_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done) {
              _context3.next = 107;
              break;
            }

            _root = _step8.value;
            _iteratorNormalCompletion3 = true;
            _didIteratorError3 = false;
            _context3.prev = 73;
            _iterator3 = (0, _asyncIterator2.default)(filter(traverse(_root), "\\.app\\/Contents\\/MacOS\\/(\\w+\\W)?".concat(name, "$"), 1));

          case 75:
            _context3.next = 77;
            return _iterator3.next();

          case 77:
            _step3 = _context3.sent;
            _iteratorNormalCompletion3 = _step3.done;
            _context3.next = 81;
            return _step3.value;

          case 81:
            _value3 = _context3.sent;

            if (_iteratorNormalCompletion3) {
              _context3.next = 88;
              break;
            }

            _file = _value3;
            return _context3.abrupt("return", _file);

          case 85:
            _iteratorNormalCompletion3 = true;
            _context3.next = 75;
            break;

          case 88:
            _context3.next = 94;
            break;

          case 90:
            _context3.prev = 90;
            _context3.t3 = _context3["catch"](73);
            _didIteratorError3 = true;
            _iteratorError3 = _context3.t3;

          case 94:
            _context3.prev = 94;
            _context3.prev = 95;

            if (!(!_iteratorNormalCompletion3 && _iterator3.return != null)) {
              _context3.next = 99;
              break;
            }

            _context3.next = 99;
            return _iterator3.return();

          case 99:
            _context3.prev = 99;

            if (!_didIteratorError3) {
              _context3.next = 102;
              break;
            }

            throw _iteratorError3;

          case 102:
            return _context3.finish(99);

          case 103:
            return _context3.finish(94);

          case 104:
            _iteratorNormalCompletion8 = true;
            _context3.next = 69;
            break;

          case 107:
            _context3.next = 113;
            break;

          case 109:
            _context3.prev = 109;
            _context3.t4 = _context3["catch"](67);
            _didIteratorError8 = true;
            _iteratorError8 = _context3.t4;

          case 113:
            _context3.prev = 113;
            _context3.prev = 114;

            if (!_iteratorNormalCompletion8 && _iterator8.return != null) {
              _iterator8.return();
            }

          case 116:
            _context3.prev = 116;

            if (!_didIteratorError8) {
              _context3.next = 119;
              break;
            }

            throw _iteratorError8;

          case 119:
            return _context3.finish(116);

          case 120:
            return _context3.finish(113);

          case 121:
            return _context3.abrupt("break", 158);

          case 122:
            _path = Shell_which(name);

            if (!_path) {
              _context3.next = 125;
              break;
            }

            return _context3.abrupt("return", _path);

          case 125:
            _iteratorNormalCompletion4 = true;
            _didIteratorError4 = false;
            _context3.prev = 127;
            _iterator4 = (0, _asyncIterator2.default)(filter(traverse('/opt'), "".concat(name, "$"), 1));

          case 129:
            _context3.next = 131;
            return _iterator4.next();

          case 131:
            _step4 = _context3.sent;
            _iteratorNormalCompletion4 = _step4.done;
            _context3.next = 135;
            return _step4.value;

          case 135:
            _value4 = _context3.sent;

            if (_iteratorNormalCompletion4) {
              _context3.next = 142;
              break;
            }

            _file2 = _value4;
            return _context3.abrupt("return", _file2);

          case 139:
            _iteratorNormalCompletion4 = true;
            _context3.next = 129;
            break;

          case 142:
            _context3.next = 148;
            break;

          case 144:
            _context3.prev = 144;
            _context3.t5 = _context3["catch"](127);
            _didIteratorError4 = true;
            _iteratorError4 = _context3.t5;

          case 148:
            _context3.prev = 148;
            _context3.prev = 149;

            if (!(!_iteratorNormalCompletion4 && _iterator4.return != null)) {
              _context3.next = 153;
              break;
            }

            _context3.next = 153;
            return _iterator4.return();

          case 153:
            _context3.prev = 153;

            if (!_didIteratorError4) {
              _context3.next = 156;
              break;
            }

            throw _iteratorError4;

          case 156:
            return _context3.finish(153);

          case 157:
            return _context3.finish(148);

          case 158:
            return _context3.abrupt("return", '');

          case 159:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this, [[6, 48, 52, 60], [12, 29, 33, 43], [34,, 38, 42], [53,, 55, 59], [67, 109, 113, 121], [73, 90, 94, 104], [95,, 99, 103], [114,, 116, 120], [127, 144, 148, 158], [149,, 153, 157]]);
  }));
  return _which.apply(this, arguments);
}